#define M 5
#define N 6
#define SIZE 30 
/* NOTE: SIZE has to be M*N */
#define CLOSED 1
#define length SIZE-1+CLOSED

/* When searching for an open path, count the initial square as visited, and look for a path of length SIZE-1 */
/* When searching for a closed path (from 0,0), don't count the initial square as visited, and look for a path of length SIZE - since the initial square is a corner, such a path will have to end on the initial square (only two moves from there) */

bit visited[SIZE];

byte x = 0;
byte y = 0;
byte count = 0;

inline path() {
/* For an open path, we should start from a random location (not so for a closed path). However, we can pick this to be in just one quarter of the board (the other cases being symmetrical). So x gets initial values 0..((M-1)/2) and y gets initial values 0..((N-1)/2) */
  do 
  :: !CLOSED && x+1<=((M-1)/2) -> x++;
  :: !CLOSED && y+1<=((N-1)/2) -> y++;
  :: break;
  od;

  visited[x+M*y] = !CLOSED;   /* mark initial square if we are searching for an open path */

  do 
  :: count<length -> if
    :: (x+2)<M && (y+1)<N &&  !visited[(x+2)+M*(y+1)] -> x=x+2; y=y+1; 
    :: (x+2)<M && (y-1)>=0 && !visited[(x+2)+M*(y-1)]  ->x=x+2; y=y-1; 
    :: (x-2)>=0 && (y+1)<N && !visited[(x-2)+M*(y+1)]  ->x=x-2; y=y+1; 
    :: (x-2)>=0 && (y-1)>=0 && !visited[(x-2)+M*(y-1)] ->x=x-2; y=y-1; 
    :: (x+1)<M && (y+2)<N  && !visited[(x+1)+M*(y+2)]->x=x+1; y=y+2; 
    :: (x+1)<M && (y-2)>=0  && !visited[(x+1)+M*(y-2)]->x=x+1; y=y-2; 
    :: (x-1)>=0 && (y+2)<N  && !visited[(x-1)+M*(y+2)]->x=x-1; y=y+2; 
    :: (x-1)>=0 && (y-2)>=0  && !visited[(x-1)+M*(y-2)]->x=x-1; y=y-2; 
    fi; 
    count++; visited[x+M*y] = 1; printf("STEP %d TO :(%d, %d) \n",count,x,y);
  :: count==length -> break;
  od;
  assert false;
}

init {
  path();
}
