Title:  Solution to FMFP'12 execercise sheet 2
Author: Ben Bittdiddle
==============================================


Assignments 1 and 2
-------------------

See the file solution2.pdf


Assignment 3
------------

(a) "improve" implements one step in Newton's method, i.e. 
y_n+1 = improve x y_n 

> improve :: Float -> Float -> Float
> improve x yn = (yn + (x/yn))/2


(b) goodEnough evaluates to "True" if and only if y is a 
close enough approximation for sqrt x, i.e. if |y^2 - x| < eps.

> goodEnough :: Float -> Float -> Bool
> goodEnough x y = abs (y*y-x) < eps


Not so nice solutions:

> goodEnough2 :: Float -> Float -> Bool
> goodEnough2 x y = if abs (y*y-x) < eps then True else False

> goodEnough3 :: Float -> Float -> Bool
> goodEnough3 x y 
>     | abs (y*y-x) < eps = True
>     | otherwise = False

Comparing to True or False is almost never needed.

  x == True                      <==>  x
  x == False                     <==>  not x
  if cond then True else False   <==>  cond


You might want to have a look at the website
  "The Evolution of a Haskell Programmer"
  http://www.willamette.edu/~fruehr/haskell/evolution.html
to see different styles and stages of a Haskell programmer.


(c)

> eps :: Float
> eps = 0.001
>
> y0 :: Float
> y0 = 1.0
> 
> mySqrt :: Float -> Float
> mySqrt x = iter y0
>  where iter y 
>           | goodEnough x y = y
>           | otherwise = iter (improve x y)

Some test cases (input/output):

       Input | expected output | actual output
-------------+-----------------+-------------------------------
        -1.0 |             ERR | does not terminate
         0.0 |               0 | 0.03125
      0.0001 |      close to 0 | 0.03230845
         2.0 |        1.414236 | 1.414216
           9 |               3 | 3.000092
          68 |       8.2462113 | 8.246214
     2553604 |            1598 | 1598.0
2553604.0001 |   close to 1598 | 1598.0      
2553603.9998 |   close to 1598 | 1598.0      
   2553603.8 |   close to 1598 | does not terminate (>45 min)

In all test cases the Haskell function mySqrt outputs correct values
except for the input 2553603.8 the function does not seem to
terminate. The approximation method might not seem too good.  Note
that for the input 0.0 the ouput 0.03125 is correct since it is "good
enough" (0.03125*0.03125<eps).


Assignment 4
------------

The function predCoin returns the next smaller coin:

> predCoin 500 = 200
> predCoin 200 = 100    
> predCoin 100 = 50  
> predCoin 50 = 20
> predCoin 20 = 10
> predCoin 10 = 5
> predCoin _  = -1

Base cases: 
* If the amount a is 0 then there is one way to change a.
* If the amount a is <0 or there are no coins left, there is no way
  to change a.
Step cases:
* Either we change a by using the coins without the highest coin or
  we change (a-d), where d is the highest coin.

> cntChange :: Int -> Int
> cntChange a = change a 500
>     where change a d 
>               | a == 0             = 1
>               | a < 0 || d == (-1) = 0
>               | otherwise          = 
>                   change a (predCoin d) + change (a-d) d


We can use lists to make the program nicer and use it for other
currencies (note: lists will be discussed later in the lecture):

> cntChangeCur :: [Int] -> Int -> Int
> cntChangeCur coins a = change a coins
>     where change a ds
>               | a==0           = 1
>               | a<0 || null ds = 0
>               | otherwise      = change a (tail ds) + change (a-(head ds)) ds
>
> cntChangeCHF    = cntChangeCur [500, 200, 100, 50, 20, 10, 5]
> cntChangeEURO   = cntChangeCur [200, 100, 50, 20, 10, 5, 2, 1]
> cntChangeDOLLAR = cntChangeCur [100, 50, 25, 10, 5, 1]

Yes, 1$ coins exist! 

Some test cases:
       Input | expected output | actual output (cntChange)
      -------+-----------------+--------------------------
          -1 |               0 | 0
           0 |               0 | 0
           5 |               1 | 1
          10 |               2 | 2
          20 |               4 | 4
           4 |               0 | 0
         100 |               ? | 50
        1000 |               ? | 104560 (takes some while)


