SOLUTION TO EXERCISE SHEET 3 FMFP'12
-------------------------------------

Authors: Zap 'n Leela -- a happy couple ?


Assignment 1:
-------------

(a)

 G |- P(0)   G |- Forall n:Nat. P(n) -> P(n+1)
==============================================
 G |- Forall n:Nat. P(n)

(b)

First we state and prove a Lemma that relates the function aux to
fibLouis:

Lemma 1: Forall n:Nat. aux n = (fibLouis n, fibLouis (n+1))
-----
Proof:
  Let P(n) := (aux n = (fibLouis n, fibLouis (n+1)))
  We show Forall n:Nat. P(n) by induction.

  Base Case: Show P(0).

	aux 0 = (0,1)                    -- aux.1
	      = (fibLouis 0, fibLouis 1)  -- fibLouis.1, fibLouis.2
    
  Step Case: Let n:Nat be arbitrary. Show that P(n) implies P(n+1).

      aux (n+1)
    = next (aux n)                                           -- aux.2
    = next (fibLouis n, fibLouis (n+1))                      -- P(n)
    = (fibLouis (n+1), fibLouis n + fibLouis (n+1))          -- next.1
    = (fibLouis (n+1), fibLouis (n+2-1) + fibLouis (n+2-2))  -- arith
    = (fibLouis (n+1), fibLouis (n+2))                       -- rev. fibLouis.3

    Note that in the first step, we actually have to check the condition that
    the argument of "aux (n+1)" really isn't equal to 0, because otherwise
    the case aux.1 would apply. This is OK, as n+1 > 0. Furthermore for the
    last step, we have to check that the left-hand side of fibLouis.3, really
    is greater than 1. This is OK, as n+2 > 1.

qed.


With the help of lemma 1, the proof of the proposition is simple.


Proposition: Forall n:Nat. fibEva n = fibLouis n
------- 

Proof: Let n be in Nat.

    fibEva n = fst (aux n)                       -- fibEva.1
             = fst (fibLouis n, fibLouis (n+1))  -- Lemma 1
             = fibLouis n                        -- Definition of fst
                                                    (see Prelude.hs)
qed.

Assignment 2:
------------

(a)

A solution without zip and map:

> otp :: [Bool] -> [Bool] -> [Bool]
> otp []     []     =          []           -- otp.1
> otp (m:ms) (k:ks) = (m/=k) : otp ms ks    -- otp.2

A more elegant solution uses zip and map:

> otp' :: [Bool] -> [Bool] -> [Bool]
> otp' m k = map (\(m,k)-> m/=k) (zip m k)

First zip the list then apply the map function on the result where the
xor is applied to each pair in the zipped list.

(b)

A function that replaces zip and map must have type
(a -> b -> c) -> [a] -> [b] -> [c]. A hoogle search
for the type returns the desired zipWith function.

> otp'' :: [Bool] -> [Bool] -> [Bool]
> otp'' = zipWith (/=)


Assignment 3:
------------

(a) 

> prime :: Int -> Bool
> prime n = [1,n] == [x | x<-[1..n], n `mod` x == 0]

We can improve the test whether n is a prime number. We only have to 
test all the numbers in [2..m], where m is the floor of the square root 
of n.

> prime' :: Int -> Bool
> prime' n
>     | n > 1     = [] == [x | x<-[2..m], n `mod` x == 0] 
>     | otherwise = False
>     where m = floor (sqrt (fromIntegral n))

(b)

> primes :: Int -> [Int]
> primes n = filter prime [2..n]

Instead of filter we can use list comprehension:

> primes' n = [p | p<-[2..n], prime p]

A less elegant solution without using the filter or list
comprehension is

> primes'' n = iter 2
>     where iter x | x > n     =     []
>                  | prime x   = x : iter (x+1)
>                  | otherwise =     iter (x+1) 

(c)

An elegant solution in Haskell uses the take function and the filter
function. For a description of the take function, see the Haskell 98
report or Prelude.hs.

> firstPrimes n = take n (filter prime [1..])

Note that Haskell evaluates the expressions lazily (lazy evaluation
will be discussed in detail in a later lecture).  Therefore,
firstPrimes n terminates for every n although [1..] is an infinite
list.

A less elegant solution is

> nextPrime :: Int -> Int
> nextPrime n = until prime increment (n+1)
>     where increment x = x+1
>
> collect :: (Int -> Int) -> Int -> Int -> [Int]
> collect _ _ 0 = []
> collect f n m = (f n) : collect f (f n) (m-1)  
>
> firstPrimes' m = collect nextPrime 1 m


Assignment 4:
------------

(a)

The auxiliary function "merge" merges two lists

> merge us [] = us
> merge [] vs = vs
> merge (u:us) (v:vs)
>     | u < v     = u : merge us     (v:vs)
>     | otherwise = v : merge (u:us) vs

> mergeSort :: [Int] -> [Int]
> mergeSort []  = []
> mergeSort [x] = [x]
> mergeSort xs  = merge (mergeSort ys) (mergeSort zs)
>     where (ys,zs) = splitAt (length xs `div` 2) xs


Another solution is to genererate first a list of singleton lists and
then merge two lists in this list until there is only one list in the
list.

We need some auxiliary functions:

> isSingleton :: [a] -> Bool
> isSingleton [_] = True
> isSingleton _   = False

> singletons :: [a] -> [[a]]
> singletons xs = [ [x] | x <- xs ]


> mergeSort' :: [Int] -> [Int]
> mergeSort' [] = []
> mergeSort' xs = head (until isSingleton mergeLists (singletons xs))
>     where mergeLists [] = []
>           mergeLists [x] = [x]
>           mergeLists (a:b:xs) = (merge a b):mergeLists xs

What is the advantage of mergeSort' over mergeSort?  Answer: Both
implementations have the same complexity in the O-notation: namely
O(nlogn). However, mergeSort' is slighly faster. Why?

Here are some test cases for our merge sort implementation:

> tcsMerge :: [([Int],[Int])]
> tcsMerge = [([],[]), ([1],[1]), ([4,3],[3,4]), ([2,4,1],[1,2,4]), 
>             ([1,2,3,4,5,6],[1,2,3,4,5,6]), ([6,5,4,3,2,1],[1,2,3,4,5,6]), 
>             ([3,45,2,2,4,2,4,3,5],[2,2,2,3,3,4,4,5,45])]

For convenience, we write a test function that takes a list
of test cases and the function to be tested.

> test f cs = map (\c -> f (fst c) == snd c) cs

We test mergeSort by
  test mergeSort tcsMerge
which returns the list [True,True,True,True,True,True,True]


Assignment 5:
------------

Recall that the function foldr is defined as
  foldr :: (a -> b -> b) -> b -> [a] -> b
  foldr f z []     =  z
  foldr f z (x:xs) =  f x (foldr f z xs)

(a) 

foldr (\x y-> 1+y) 0 [1,2,3] =
1 + (foldr (\x y-> 1+y) 0 [2,3]) =
1 + (1 + (foldr (\x y-> 1+y) 0 [3])) =
1 + (1 + (1 + (foldr (\x y-> 1+y) 0 []))) =
1 + (1 + (1 + 0)) =
1 + (1 + 1) =
1 + 2 =
3

The function 
  foldr (\_ y-> 1+y) 0 
has type [a] -> Int and returns the length of the given list.

(b)

Claim: foldr (:) [] is the identity function on lists.

Proof: 
  Let P(xs) := foldr (:) [] xs = xs
  We prove by induction over lists that Forall xs::[a]. P(xs) holds.

Base case: Show P([]).
   foldr (:) [] [] = []         -- foldr.1

Step case: Let x::a and xs::[a] be arbitrary. Show that P(xs) implies P(x:xs).
 
     foldr (:) [] (x:xs)          
   = (:) x (foldr (:) [] xs)      -- foldr.2
   = (:) x xs                     -- P(xs)
   = (x:xs)                       -- syntax change