SOLUTION TO EXERCISE SHEET 5 FMFP'12
-------------------------------------

Author: #45|< 311 8R00|< 2 C(_)RRY _|R.

> import Prelude hiding (Left,Right)
> import Data.List (nub)


Assignment 1:
------------

(a)

  1. (\x y z -> x (y z))    :: (b -> c) -> (a -> b) -> (a -> c)

  2. (\f -> (\h -> (f,h)))  :: a -> b -> (a,b)

  3. map (elem 0)           :: Num a => [[a]] -> [Bool]

  4. (\x -> x (<))          :: Ord b => ((b -> b -> Bool) -> c) -> c


(b)

  A |- t1 :: \sigma   A,x:\sigma |- t2 :: \tau
  ------------------------------------------------ x \notin A
  A |- let x = t1 in t2 :: \tau


Assignment 2:
-------------

See the file solution5.pdf


Assignment 3:
-------------

(a)

> data Prop a = Var a | Not (Prop a)
>             | And (Prop a) (Prop a) | Or (Prop a) (Prop a) 
>               deriving Show                          
     
(b)

The 'foldProp' function takes an individual combination function for each
constructor. The types of these functions corresponds to the types of the
corresponding constructor, where each type recursion is replaced by the result
type 'b' of the fold.

> foldProp :: (a -> b) -> (b -> b) -> (b -> b -> b) -> (b -> b -> b) -> 
>             Prop a -> b
> foldProp fvar fnot fand for = 
>     go
>   where 
>     go (Var name) = fvar name
>     go (Not x)    = fnot (go x)
>     go (And x y)  = fand (go x) (go y)
>     go (Or  x y)  = for  (go x) (go y)

(c)

> evalProp :: (a -> Bool) -> Prop a -> Bool
> evalProp v = foldProp v not (&&) (||)

(d)

> propVars :: Prop a -> [a]
> propVars = foldProp (\x->[x]) id (++) (++)

(e) 

The basic idea: 

- Collect all variables that occur in a formula.
- Build all assignment for these variables.
- Evaluate the proposition with all of these 
  assignments.
- The formula is satisfiable if and only if it evaluates 
  to True for one of these variable assignments.

The function vars returns the list of variables that occur 
in a given formula.

> satProp :: Eq a => Prop a -> Bool
> satProp p = any (\f -> evalProp f p) assg
>   where assg = map (flip elem) (pow (nub (propVars p)))

The function 'nub' from Data.List removes all duplicate elements of a list.
The powerset of a list interpreted as a set is computed as follows.

> pow :: [a] -> [[a]]
> pow [] = [[]]
> pow (x:xs) = map (x:) (pow xs)  ++ (pow xs)

Some simple test cases:

> prop1 = And (Var 1) (Var 1)
> prop2 = And (Var 1) (Not (Var 1))
> prop3 = And (Var 1) (Not (Var 2))


Assignment 4:
------------

> data Tree a = Leaf | Node a (Tree a) (Tree a) 
>               deriving (Eq,Ord,Show)

(a)

> bfs :: Tree a -> [a]
> bfs x = traverse [x]

> traverse :: [Tree a] -> [a]
> traverse [] = []
> traverse ts = rootlabels ++ traverse children
>     where rootlabels = [ x | Node x _ _ <- ts]
>           children   = [ t | Node _ l r <- ts, t <- [l,r] ]

(b)

mapTree f Leaf = Leaf                                                [mapTree.1]
mapTree f (Node x t1 t2) = Node (f x) (MapTree f t1) (mapTree f t2)  [mapTree.2]


Let f::a->b and g::b->c be arbitrary functions.

Claim: Forall t::Tree a. mapTree g (mapTree f t) = mapTree (g.f) t
------
Proof: 
  Let P(t) := mapTree g (mapTree f t) = mapTree (g.f) t
  We prove Forall t::Tree a. P(t) by induction.

  Base Case: Show that P(Leaf) holds.
    mapTree g (mapTree f Leaf)
  = mapTree g Leaf               -- mapTree.1
  = Leaf                         -- mapTree.1
  = mapTree (g.f) Leaf           -- mapTree.1 (reversed)
				  

  Step Case: Let x::a, l::Tree a, r::Tree a be arbitrary. Show that
             P(l) and P(r) imply P(Node x l r).

    mapTree g (mapTree f (Node x l r))
  = mapTree g (Node (f x) (mapTree f l) (mapTree f r))                 -- mapTree.2
  = Node (g (f x)) (mapTree g (mapTree f l)) (mapTree g (mapTree f r)) -- mapTree.2
  = Node (g (f x)) (mapTree (g.f) l) (mapTree (g.f) r)                 -- P(l),P(r)
  = Node ((g.f) x)) (mapTree (g.f) l) (mapTree (g.f) r)                -- def (.)
  = mapTree (g.f) (Node a l r)                                         -- rev. mapTree.2

qed.


