SOLUTION TO EXERCISE SHEET 6 FMFP'12
-------------------------------------

Author: Zap Branigan

Assignment 1:
------------

We use ~~> to denote beta-reduction steps.

(i) lazy evaluation of F G:

      (\x -> x (\y -> x y)) (\x -> y x)
  [ Note the renaming of \y necessary to avoid capturing the free 'y' in G ]
  ~~> (\x -> y x) (\z -> (\x -> y x) z)
  ~~> y (\z -> (\x -> y x) z)

(ii) eager evaluation of F G:

      (\x -> x (\y -> x y)) (\x -> y x)
  ~~> (\x -> y x) (\z -> (\x -> y x) z)
  [ Here, we have a case of evaluation of the argument and under abstraction ]
  ~~> (\x -> y x) (\z -> y z)
  ~~> y (\z -> y z)



Assignment 2:
------------

Remember the following function definitions:

  foldr f z []     = z                     -- foldr.1
  foldr f z (x:xs) = f x (foldr f z xs)    -- foldr.2
 
  foldl f z []     = z                     -- foldl.1
  foldl f z (x:xs) = foldl f (f z x) xs    -- foldl.2


Lemma: FORALL f::(b -> a -> b) xs::[a] z::b.
         foldl f z xs = foldr (\x r l -> r (f l x)) id xs z

Proof:
  Let f::(b -> a -> b) be arbitrary.
  Let g := (\x r l -> r (f l x)).
  Let P(xs) := FORALL z::b. foldl f z xs = foldr g id xs z
  We prove FORALL xs::[a]. P(xs) by induction.

  Case [] :
    Show P([]). Let z::b be arbitrary.

      foldl f z []
    =             -- foldl.1
      z                                          
    =             -- beta-reduction
      (\x -> x) z
    =             -- id definition
      id z                                       
    =             -- foldr.1
      foldr g id [] z        

  Case (:) :
    Let x::a, xs::[a] be arbitrary.
    Assume P(xs), i.e., 
      FORALL w::b. foldl f w xs = foldr g id xs w
    Note that we renamed the bound variable 'z' in P(xs) to 'w' to simplify
    referencing it in later proof steps.

    Show P(x:xs), i.e., we have to prove
      FORALL z::b. foldl f z (x:xs) = foldr g id (x:xs) z .
    Let z::b be arbitrary. 

      foldl f z (x:xs)
    =                    -- foldl.2
      foldl f (f z x) xs                         
    =                    -- P(xs) with w := (f z x)
      foldr g id xs (f z x)
    =                    -- beta-reduction
      (\x r l -> r (f l x)) x (foldr g id xs) z  
    =                    -- definition g
      g x (foldr g id xs) z  
    =                    -- foldr.2
      foldr g id (x:xs) z

qed.


Assignment 3:
-------------

The type of multivariate polynomials over variables of type 'a' with
'Integer' coefficients is defined as follows.

> type Poly a = [(Integer, [a])]


(a)
The function 'evalPoly' evaluates a polynomial under a valuation for the
variables.

> evalPoly :: (a -> Integer) -> Poly a -> Integer
> evalPoly f p = sum [ a * product (map f xs) | (a, xs) <- p ]

(b)
Symbolic arithmetic expression are represented by the following data type.

> data AExpr a = Var a
>              | Lit Integer 
>              | Add (AExpr a) (AExpr a)
>              | Mul (AExpr a) (AExpr a)

The corresponding fold function is defined as follows.

> foldAExpr :: (a -> b) -> (Integer -> b) -> (b -> b -> b) -> (b -> b -> b) 
>           -> AExpr a -> b
> foldAExpr fVar fLit fAdd fMul =
>     go
>   where
>     go (Var x)   = fVar x
>     go (Lit i)   = fLit i
>     go (Add l r) = fAdd (go l) (go r)
>     go (Mul l r) = fMul (go l) (go r)

(c)
The induction scheme for structural induction over 'AExpr a' is:

G |- FORALL v :: a.                                     P(Var v) 
G |- FORALL i :: Integer.                               P(Lit i)
G |- FORALL l :: AExpr a, r :: AExpr a. P(l) & P(r) ==> P(Add l r) 
G |- FORALL l :: AExpr a, r :: AExpr a. P(l) & P(r) ==> P(Mul l r)
==================================================================
G |- FORALL e :: AExpr a. P(e)

(d)
The function 'foldAExpr' can be used to define the following conversion function.

> toPoly :: AExpr a -> Poly a
> toPoly = 
>     foldAExpr var lit (++) mul
>   where
>     var x   = [(1, [x])]
>     lit i   = [(i, [] )]
>     mul l r = [(a1 * a2, xs1 ++ xs2) | (a1, xs1) <- l, (a2, xs2) <- r]


Assignment 4:
-------------

(a)
1. Prelude> :t \x y z -> head (map x y) y
\x y z -> head (map x y) y :: (a -> [a] -> b) -> [a] -> c -> b

2. Prelude> :t \x y z w -> z (x + 0) + w (y + 1)
\x y z w -> z (x + 0) + w (y + 1) :: (Num a, Num b, Num c) => a -> b -> (a -> c) -> (b -> c) -> c

3. Prelude> :t \x y z -> x y (y z) (fst z)
\x y z -> x y (y z) (fst z) :: (((a,b) -> c) -> c -> a -> d) -> ((a,b) -> c) -> (a,b) -> d

4. Prelude> :t \x y z -> (x y < z x) < (3 < 4)
\x y z -> (x y < z x) < (3 < 4) :: (Ord a) => (b -> a) -> b -> ((b -> a) -> a) -> Bool


(b) 

G:= c:(a, Int) -> Int, x:(a,Int)

========================     =================
G |- c :: (a,Int) -> Int     G |- x :: (a,Int)
==============================================
G |- c x :: Int
==========================                                        =========================
G |- iszero (c x) :: Bool                                         x:(a,Int) |- x :: (a,Int)
===============================================================   =================================
c:(a, Int) -> Int |- (\x. iszero (c x)) :: (a,Int) -> Bool        x:(a,Int) |- snd x :: Int
===============================================================   =================================
|- (\c x. iszero (c x)) :: ((a, Int) -> Int) -> (a,Int) -> Bool   |- (\x. snd x) :: (a, Int) -> Int
===================================================================================================
|- (\c x. iszero (c x)) (\x. snd x) :: (a,Int) ->  Bool

